"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JSON_API_SDK_CONFIG = exports.AtomicFactory = exports.provideJsonApi = exports.getProviders = void 0;
const core_1 = require("@angular/core");
const http_1 = require("@angular/common/http");
const token_1 = require("./token");
const utils_1 = require("./utils");
const service_1 = require("./service");
const getProviders = (config) => [
    {
        provide: token_1.JSON_API_SDK_CONFIG,
        useValue: (0, utils_1.resultConfig)(config),
    },
    {
        provide: service_1.JsonApiUtilsService,
        useFactory: () => new service_1.JsonApiUtilsService((0, core_1.inject)(token_1.JSON_API_SDK_CONFIG)),
    },
    {
        provide: service_1.JsonApiSdkService,
        useFactory: () => new service_1.JsonApiSdkService((0, core_1.inject)(http_1.HttpClient), (0, core_1.inject)(service_1.JsonApiUtilsService), (0, core_1.inject)(token_1.JSON_API_SDK_CONFIG)),
    },
    {
        provide: token_1.AtomicFactory,
        useFactory: () => {
            const jsonApiUtilsService = (0, core_1.inject)(service_1.JsonApiUtilsService);
            const config = (0, core_1.inject)(token_1.JSON_API_SDK_CONFIG);
            const httpClient = (0, core_1.inject)(http_1.HttpClient);
            return () => {
                return new service_1.AtomicOperationsService(jsonApiUtilsService, config, httpClient);
            };
        },
    },
];
exports.getProviders = getProviders;
const provideJsonApi = (config) => (0, core_1.makeEnvironmentProviders)((0, exports.getProviders)(config));
exports.provideJsonApi = provideJsonApi;
var token_2 = require("./token");
Object.defineProperty(exports, "AtomicFactory", { enumerable: true, get: function () { return token_2.AtomicFactory; } });
Object.defineProperty(exports, "JSON_API_SDK_CONFIG", { enumerable: true, get: function () { return token_2.JSON_API_SDK_CONFIG; } });
//# sourceMappingURL=json-api-angular.js.map