"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchInnerClient = void 0;
const fetch_1 = require("rxjs/fetch");
const utils_1 = require("../utils");
class FetchInnerClient {
    delete(url, body) {
        let requestInit = {
            method: 'delete',
        };
        if (body) {
            requestInit = Object.assign(Object.assign({}, requestInit), { body: JSON.stringify(body) });
        }
        return this.request(url, requestInit);
    }
    get(url, params) {
        let filterParams = {};
        if (params) {
            ({ params: filterParams } = params);
        }
        return this.request(this.getResultUrl(url, filterParams), {
            method: 'get',
        });
    }
    patch(url, body) {
        return this.request(url, {
            method: 'patch',
            body: JSON.stringify(body),
        });
    }
    post(url, body) {
        return this.request(url, {
            method: 'post',
            body: JSON.stringify(body),
        });
    }
    request(url, initData) {
        return (0, fetch_1.fromFetch)(url, Object.assign(Object.assign({}, initData), { selector: (r) => r.json() }));
    }
    getResultUrl(url, params) {
        const paramsStr = new utils_1.HttpParams({ fromObject: params }).toString();
        if (paramsStr.length === 0)
            return url;
        return new URL('?' + new utils_1.HttpParams({ fromObject: params }).toString(), url).toString();
    }
}
exports.FetchInnerClient = FetchInnerClient;
//# sourceMappingURL=fetch-inner-client.js.map