import { RelationKeys, MainData, ResourceObject, ResourceObjectRelationships } from '@yaser2us/json-api-nestjs-shared';
import { JsonApiSdkConfig, QueryParams, Relationships, ReturnIfArray } from '../types';
import { HttpParams } from '../utils';
type RelationData = MainData;
export declare class JsonApiUtilsService {
    private jsonApiSdkConfig;
    constructor(jsonApiSdkConfig: JsonApiSdkConfig);
    getUrlForResource(resource: string): string;
    getQueryStringParams<Entity>(params?: QueryParams<Entity>): HttpParams;
    private getIncludeParam;
    private getSortParam;
    private getPageParam;
    private getFieldParam;
    private getFilterParam;
    convertResponseData<E extends object>(body: ResourceObject<E>, includeEntity?: QueryParams<E>['include']): E;
    convertResponseData<E extends object, IdKey extends string>(body: ResourceObject<E, 'array', null, IdKey>, includeEntity?: QueryParams<E>['include']): E[];
    convertResponseData<E extends object, IdKey extends string>(body: ResourceObject<E, 'object', null, IdKey>, includeEntity?: QueryParams<E>['include']): E;
    convertResponseData<E extends object, IdKey extends string>(body: ResourceObject<E, 'array', null, IdKey>, includeEntity?: QueryParams<E>['include']): E[];
    createEntityInstance<E>(name: string): E;
    private findIncludeEntity;
    generateBody<E extends object>(entity: E): {
        attributes: {} | undefined;
        relationships: Relationships<E>;
    };
    getResultForRelation<Entity extends object, IdKey extends string, Rel extends RelationKeys<Entity, IdKey>>(body: ResourceObjectRelationships<Entity, IdKey, Rel>): ReturnIfArray<Entity[Rel], string>;
    generateRelationshipsBody<RelationshipEntity extends object>(relationshipEntity: RelationshipEntity | RelationshipEntity[]): RelationData | RelationData[];
}
export {};
