import { RelationKeys } from '@yaser2us/json-api-nestjs-shared';
import { AtomicMainOperations, JsonApiSdkConfig, BodyType } from '../types';
import { JsonApiUtilsService } from '../service';
export type AtomicVoidOperation = {
    [K in keyof AtomicMainOperations<[]>]: (...arg: any) => void;
};
export declare class GenerateAtomicBody<Entity extends object = any, Rel extends RelationKeys<Entity> = any> implements AtomicVoidOperation {
    private jsonApiUtilsService;
    private jsonApiSdkConfig;
    constructor(jsonApiUtilsService: JsonApiUtilsService, jsonApiSdkConfig: JsonApiSdkConfig);
    private bodyData;
    private skipEmpty;
    get isSkipEmpty(): boolean;
    private setToBody;
    getBody(): BodyType;
    postOne(entity: Entity): void;
    patchOne(entity: Entity): void;
    deleteOne(entity: Entity, skipEmpty: boolean): void;
    patchRelationships(entity: Entity, relationType: Rel): void;
    postRelationships(entity: Entity, relationType: Rel): void;
    deleteRelationships(entity: Entity, relationType: Rel): void;
}
