"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isRelation = isRelation;
exports.getTypeForReq = getTypeForReq;
exports.resultConfig = resultConfig;
const change_case_commonjs_1 = require("change-case-commonjs");
const constants_1 = require("../constants");
function isRelation(val) {
    const result = !(val === null ||
        !val ||
        ['String', 'Boolean', 'Number', 'Date'].includes(val.constructor.name));
    if (!result)
        return result;
    return constants_1.ID_KEY in val;
}
function getTypeForReq(str) {
    return (0, change_case_commonjs_1.kebabCase)(str).toLowerCase();
}
function resultConfig(partialConfig) {
    return Object.assign(Object.assign({}, partialConfig), { idKey: partialConfig.idKey ? partialConfig.idKey : constants_1.ID_KEY, idIsNumber: partialConfig.idIsNumber === undefined
            ? true
            : !!partialConfig.idIsNumber, dateFields: partialConfig.dateFields ? partialConfig.dateFields : [] });
}
//# sourceMappingURL=utils.js.map