import { Observable } from 'rxjs';
import { RelationKeys } from '@yaser2us/json-api-nestjs-shared';
import { JsonApiUtilsService } from './json-api-utils.service';
import { AtomicOperations, HttpInnerClient, JsonApiSdkConfig, ReturnIfArray } from '../types';
export declare class AtomicOperationsService<T extends unknown[]> implements AtomicOperations<T> {
    private jsonApiUtilsService;
    private jsonApiSdkConfig;
    private httpInnerClient;
    private generateAtomicBody;
    constructor(jsonApiUtilsService: JsonApiUtilsService, jsonApiSdkConfig: JsonApiSdkConfig, httpInnerClient: HttpInnerClient);
    private addBody;
    run(): Observable<T>;
    deleteOne<Entity extends object>(entity: Entity): AtomicOperations<[...T]>;
    deleteOne<Entity extends object>(entity: Entity, skipEmpty: true): AtomicOperations<[...T]>;
    deleteOne<Entity extends object>(entity: Entity, skipEmpty: false): AtomicOperations<[...T, 'EMPTY']>;
    patchOne<Entity extends object>(entity: Entity): AtomicOperations<[...T, Entity]>;
    postOne<Entity extends object>(entity: Entity): AtomicOperations<[...T, Entity]>;
    deleteRelationships<Entity extends object, Rel extends RelationKeys<Entity>>(entity: Entity, relationType: Rel): AtomicOperations<T>;
    patchRelationships<Entity extends object, Rel extends RelationKeys<Entity>>(entity: Entity, relationType: Rel): AtomicOperations<[...T, ReturnIfArray<Entity[Rel], string>]>;
    postRelationships<Entity extends object, Rel extends RelationKeys<Entity>>(entity: Entity, relationType: Rel): AtomicOperations<[...T, ReturnIfArray<Entity[Rel], string>]>;
    private setToBody;
}
