import { fromFetch } from 'rxjs/fetch';
import { HttpParams } from '../utils';
export class FetchInnerClient {
    delete(url, body) {
        let requestInit = {
            method: 'delete',
        };
        if (body) {
            requestInit = {
                ...requestInit,
                body: JSON.stringify(body),
            };
        }
        return this.request(url, requestInit);
    }
    get(url, params) {
        let filterParams = {};
        if (params) {
            ({ params: filterParams } = params);
        }
        return this.request(this.getResultUrl(url, filterParams), {
            method: 'get',
        });
    }
    patch(url, body) {
        return this.request(url, {
            method: 'patch',
            body: JSON.stringify(body),
        });
    }
    post(url, body) {
        return this.request(url, {
            method: 'post',
            body: JSON.stringify(body),
        });
    }
    request(url, initData) {
        return fromFetch(url, {
            ...initData,
            selector: (r) => r.json(),
        });
    }
    getResultUrl(url, params) {
        const paramsStr = new HttpParams({ fromObject: params }).toString();
        if (paramsStr.length === 0)
            return url;
        return new URL('?' + new HttpParams({ fromObject: params }).toString(), url).toString();
    }
}
//# sourceMappingURL=fetch-inner-client.js.map